/*! phpMyFAQ v3.0.0-alpha - http://www.phpmyfaq.de/ - Copyright (c) 2001 - 2018 Thorsten Rinne and phpMyFAQ Team */
/**
 * Add FAQ functionality JavaScript part
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/.
 *
 * @category  phpMyFAQ
 * @package   JavaScript
 * @author    Thorsten Rinne
 * @copyright 2017 phpMyFAQ Team
 * @license   http://www.mozilla.org/MPL/2.0/ Mozilla Public License Version 2.0
 * @link      http://www.phpmyfaq.de
 * @since     2017-08-02
 */

/*global document: false, $: false, tinyMCE: false, saveFormValues: false */

$(document).ready(function() {
  'use strict';
  $('#submitfaq').click(function() {
    if (typeof tinyMCE !== 'undefined' && undefined !== tinyMCE) {
      tinyMCE.get('answer').setContent(tinyMCE.activeEditor.getContent());
      document.getElementById('answer').value = tinyMCE.activeEditor.getContent();
    }
    saveFormValues('savefaq', 'faq');
  });
  $('form#formValues').submit(function() { return false; });
});
/**
 * Autosave functionality JavaScript part
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/.
 *
 * @category  phpMyFAQ
 * @package   JavaScript
 * @author    Anatoliy Belsky <ab@php.net>
 * @copyright 2012-2018 phpMyFAQ Team
 * @license   http://www.mozilla.org/MPL/2.0/ Mozilla Public License Version 2.0
 * @link      http://www.phpmyfaq.de
 * @since     2012-07-07
 */

/*global document: false, window: false, $: false */

$(document).ready(function () {
    'use strict';
    $(window).on('unload', function () {
        if (typeof window.tinyMCE !== "undefined" && window.tinyMCE.activeEditor !== null) {
            if (window.tinyMCE.activeEditor.isDirty()) {
                var chk = window.confirm('Do you want to save the article before navigating away?');

                if (chk) {
                    pmfAutosave();
                }
            }
        }
    });

    if (typeof window.tinyMCE !== "undefined" && typeof pmfAutosaveInterval !== "undefined") {
        setInterval(function () {
            pmfAutosave();
        },
        window.pmfAutosaveInterval * 1000);
    }

    /**
     * Post autosave data via AJAX.
     *
     * @return void
     */
    function pmfAutosave() {
        var ed = window.tinyMCE.activeEditor;
        if (ed.isDirty()) {
            var formData = {};
            formData.revision_id = $('#revision_id').attr('value');
            formData.record_id = $('#record_id').attr('value');
            formData.csrf = $('[name="csrf"]').attr('value');
            formData.openQuestionId = $('#openQuestionId').attr('value');
            formData.question = $('#question').attr('value');
            formData.answer = ed.getContent();
            formData.keywords = $('#keywords').attr('value');
            formData.tags = $('#tags').attr('value');
            formData.author = $('#author').attr('value');
            formData.email = $('#email').attr('value');
            formData.lang = $('#lang').attr('value');
            formData.solution_id = $('#solution_id').attr('value');
            formData.active = $('input:checked:[name="active"]').attr('value');
            formData.sticky = $('#sticky').attr('value');
            formData.comment = $('#comment').attr('value');
            formData.grouppermission = $('[name="grouppermission"]').attr('value');
            formData.userpermission = $('[name="userpermission"]').attr('value');
            formData.restricted_users = $('[name="restricted_users"]').attr('value');
            formData.dateActualize = $('#dateActualize').attr('value');
            formData.dateKeep = $('#dateKeep').attr('value');
            formData.dateCustomize = $('#dateCustomize').attr('value');
            formData.date = $('#date').attr('value');

            $.ajax({
                url: pmfAutosaveAction(),
                type: 'POST',
                data: formData,
                success: function (r) {
                    var resp = $.parseJSON(r);

                    $('#saving_data_indicator').html(resp.msg);

                    ed.isNotDirty = true;

                    $('#record_id').attr('value', resp.record_id);
                    $('#revision_id').attr('value', resp.revision_id);
                    /* XXX update more places on the page according to the new saved data */
                }
            });
        }
    }

    /**
     * Produce AJAX autosave action.
     *
     * @return string
     */
    function pmfAutosaveAction() {
        var act,
            fa = $("#faqEditor").attr("action");

        act = "?action=ajax&ajax=autosave&" + fa.substr(1).replace(/action=/, "do=");

        return act;
    }
});
/**
 * Category functions
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/.
 *
 * @category  phpMyFAQ
 * @package   JavaScript
 * @author    Hamed Ayari <hamed.ayari@maxdome.de>
 * @author    Thorsten Rinne <thorsten@phpmyfaq.de>
 * @copyright 2016-2018 phpMyFAQ Team
 * @license   http://www.mozilla.org/MPL/2.0/ Mozilla Public License Version 2.0
 * @link      http://www.phpmyfaq.de
 * @since     2016-03-25
 */

/*global $: false */

$(document).ready(function () {
    'use strict';

    var menuCounter = 0;
    $('.pmf-category-overview').find('li').not('ul:first').each(function () {
        if ($(this).children('ul').length > 0) {
            $(this).addClass('pmf-main-category');
            if ($(this).data('category-level') === 0) {
                $(this).prepend('<i class="fa fa-arrow-circle-o-right"></i> ');
            } else {
                $(this).prepend('<i class="fa fa-circle-o"></i> ');
            }
            var subCat = $(this).find('a:first');
            subCat.addClass('pmf-sub-category');
            ++menuCounter;

            if (subCat.parent('li').children('ul').length > 0) {
                subCat.parent('li').children('ul').addClass('pmf-sub-category-list');
            } else {
                ++menuCounter;
            }
        } else {
            $(this).prepend('<i class="fa fa-circle-o"></i> ');
        }
    });

    if (menuCounter > 50) {
        $('.pmf-main-category').find('ul').hide();
        $('.pmf-sub-category-list').hide();
    } else{
        $('.pmf-main-category').find('ul').show();
    }

    // Toggle
    $('.fa.fa-arrow-circle-o-right').on('click', function (event) {
        event.preventDefault();
        var parentList = $(this).parent('li');
        if(parentList.has( 'ul').length > 0) {
            parentList.find('ul').slideToggle();
        }
    });
});
/**
 * Comment functionality
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/.
 *
 * @category  phpMyFAQ
 * @author    Thorsten Rinne <thorsten@phpmyfaq.de>
 * @copyright 2016 phpMyFAQ Team
 * @license   http://www.mozilla.org/MPL/2.0/ Mozilla Public License Version 2.0
 * @link      http://www.phpmyfaq.de
 * @since     2016-01-11
 */

/*global $:false */

$(function () {
    'use strict';

    /**
     * Show full comment
     *
     * @param id
     */
    var showLongComment = function (id) {
        $('.comment-more-' + id).removeClass('hide');
        $('.comment-dots-' + id).addClass('hide');
        $('.comment-show-more-' + id).addClass('hide');
    };


    //
    // Event listeners
    //
    $('.show-comment-form').on('click', function(event) {
        event.preventDefault();
        $('#pmf-create-comment').removeClass('hide');
        document.getElementById('pmf-create-comment').scrollIntoView();
    });

    $('.pmf-comments-show-more').on('click', function (event) {
        var commentId = $(this).data('comment-id');
        event.preventDefault();
        showLongComment(commentId);
    });

});

/**
 * TinyMCE code to add FAQ functionality JavaScript part
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/.
 *
 * @category  phpMyFAQ
 * @package   JavaScript
 * @author    Thorsten Rinne
 * @copyright 2017 phpMyFAQ Team
 * @license   http://www.mozilla.org/MPL/2.0/ Mozilla Public License Version 2.0
 * @link      http://www.phpmyfaq.de
 * @since     2017-08-02
 */

/*global document: false, $: false, tinyMCE: false */

$(document).ready(function() {
  'use strict';
  if (typeof tinyMCE !== 'undefined' && undefined !== tinyMCE) {
    tinyMCE.init({
      // General options
      mode     : 'exact',
      language : 'en',
      elements : 'answer',
      theme    : 'modern',
      plugins: [
        'advlist autolink lists link image charmap print preview hr anchor pagebreak',
        'searchreplace wordcount visualblocks visualchars code fullscreen',
        'insertdatetime media nonbreaking save table contextmenu directionality',
        'emoticons template paste textcolor'
      ],
      relative_urls: false,
      convert_urls: false,
      remove_linebreaks: false,
      use_native_selects: true,
      paste_remove_spans: true,
      entities : '10',
      entity_encoding: 'raw',

      toolbar1: "insertfile undo redo | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent",
      toolbar2: "link | forecolor backcolor emoticons | print",
      image_advtab: true,

      // Formatting
      style_formats: [
        {  title: 'Headers', items: [
          {  title: 'h1', block: 'h1'  },
          {  title: 'h2', block: 'h2'  },
          {  title: 'h3', block: 'h3'  },
          {  title: 'h4', block: 'h4'  },
          {  title: 'h5', block: 'h5'  },
          {  title: 'h6', block: 'h6'  }
        ] },

        {  title: 'Blocks', items: [
          {  title: 'p', block: 'p'  },
          {  title: 'div', block: 'div'  },
          {  title: 'pre', block: 'pre'  },
          {  title: 'code', block: 'code'  }
        ] },

        {  title: 'Containers', items: [
          {  title: 'blockquote', block: 'blockquote', wrapper: true  },
          {  title: 'figure', block: 'figure', wrapper: true  }
        ] }
      ],

      visualblocks_default_state: true,
      end_container_on_empty_block: true,
      extended_valid_elements : "code[class],video[*],audio[*],source[*]",
      removeformat : [
        {  selector : '*', attributes : ['style'], split : false, expand : false, deep : true  }
      ],
      importcss_append: true,
    });
  }
});
/**
 * FAQ page
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/.
 *
 * @category  phpMyFAQ
 * @package   JavaScript
 * @author    Thorsten Rinne
 * @copyright 2018 phpMyFAQ Team
 * @license   http://www.mozilla.org/MPL/2.0/ Mozilla Public License Version 2.0
 * @link      http://www.phpmyfaq.de
 * @since     2018-01-06
 */

/*global document: false, $: false, saveVoting: false, hljs: false */

/*
 * Voting
 *
 */
$(document).ready(function() {
  'use strict';
  $(function () {
    $('div.pmf-stars > div.pmf-star-rating > span').on('click', function (e) {
      var numStars = $(e.target).data('stars');
      saveVoting('faq', '{{ id }}', numStars, '{{ lang }}');
    });
  });
});

/**
 * HighlightJS
 *
 */
$('pre code').each(function(i, block) {
  'use strict';
  hljs.highlightBlock(block);
});

/**
 * bxSlider
 *
 */
$('.bxslider').bxSlider();
/**
 * FAQ record functions
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/.
 *
 * @category  phpMyFAQ
 * @package   JavaScript
 * @author    Hamed Ayari <hamed.ayari@maxdome.de>
 * @author    Thorsten Rinne <thorsten@phpmyfaq.de>
 * @copyright 2016 phpMyFAQ Team
 * @license   http://www.mozilla.org/MPL/2.0/ Mozilla Public License Version 2.0
 * @link      http://www.phpmyfaq.de
 * @since     2016-03-25
 */

/*global $: false, saveFormValues: false, mermaid: false */

$(document).ready(function () {
    'use strict';

    //
    // Show rating
    //
    var rating = $('#rating span').data('rating');
    if (0 < rating) {
        rating = Math.floor(rating);
        $('.pmf-star-rating').children('span').each(function () {
            if ($(this).data('stars') <= rating) {
                $(this).text('★');
            }
        });
    }

    //
    // Save comments
    //
    $('form#formValues').on('submit', function (e) {
        e.preventDefault();
        saveFormValues('savecomment', 'comment');
        return false;
    });

    //
    // Tooltips
    //
    $('[data-toggle="tooltip"]').tooltip();

    //
    // Initialize Mermaid
    //
    var config = {
        startOnLoad:true,
        arrowMarkerAbsolute:true
    };
    mermaid.initialize(config);
});

/**
 * Typeahead functionality JavaScript part
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/.
 *
 * @category  phpMyFAQ
 * @package   JavaScript
 * @author    Thorsten Rinne <thorsten@phpmyfaq.de>
 * @copyright 2014-2018 phpMyFAQ Team
 * @license   http://www.mozilla.org/MPL/2.0/ Mozilla Public License Version 2.0
 * @link      http://www.phpmyfaq.de
 * @since     2014-11-23
 */

/*global $: false, Bloodhound: false, Handlebars: false */

$(window).on('load', function () {
    'use strict';

    // instantiate the bloodhound suggestion engine
    var questions = new Bloodhound({
        datumTokenizer: Bloodhound.tokenizers.whitespace,
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        limit: Number.MAX_VALUE,
        remote: {
            url: 'ajaxresponse.php?search=%QUERY',
            wildcard: '%QUERY',
            transform: function (questions) {
                return $.map(questions.results, function (question) {
                    return {
                        category: question.categoryName,
                        question: question.faqQuestion,
                        url: question.faqLink
                    };
                });
            }
        }
    });
    // instantiate the typeahead UI
    $('.typeahead').typeahead(null, {
        display: 'suggestion',
        source: questions.ttAdapter(),
        templates: {
            notFound: [
                '<div class="empty-message">',
                'Nothing found... :-(',
                '</div>'
            ].join('\n'),
            suggestion: Handlebars.compile(
                '<div><strong>{{category}}</strong>: <a href="{{url}}">{{question}}</a></div>'
            )
        }
    }).on('typeahead:selected typeahead:autocompleted', function () {
        $('#searchfield').submit();
    });
});
/**
 * Some JavaScript functions used in the admin backend
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/.
 *
 * @category  phpMyFAQ
 * @author    Thorsten Rinne <thorsten@phpmyfaq.de>
 * @author    Periklis Tsirakidis <tsirakidis@phpdevel.de>
 * @author    Matteo Scaramuccia <matteo@scaramuccia.com>
 * @author    Minoru TODA <todam@netjapan.co.jp>
 * @author    Lars Tiedemann <php@larstiedemann.de>
 * @copyright 2003-2018 phpMyFAQ Team
 * @license   http://www.mozilla.org/MPL/2.0/ Mozilla Public License Version 2.0
 * @link      http://www.phpmyfaq.de
 * @since     2003-11-13
 */

/*global document: false, window: false, $: false */

var infoBox,
    selectSelectAll,
    selectUnselectAll,
    closeWindow,
    addAttachmentLink,
    saveVoting;

$(document).ready(function () {
    'use strict';

    /**
     * selects all list options in the select with the given ID.
     *
     * @param select_id
     * @return void
     */
    selectSelectAll = function selectSelectAll(select_id) {
        var selectOptions = $('#' + select_id + ' option'),
            i = 0;
        for (i = 0; i < selectOptions.length; i += 1) {
            selectOptions[i].selected = true;
        }
    };

    /**
     * unselects all list options in the select with the given ID.
     *
     * @param select_id
     * @return void
     */
    selectUnselectAll = function selectUnselectAll(select_id) {
        var selectOptions = $('#' + select_id + ' option'),
            i = 0;
        for (i = 0; i < selectOptions.length; i += 1) {
            selectOptions[i].selected = false;
        }
    };

    /**
     * Displays or hides the info boxes
     *
     * @return void
     */
    infoBox = function infoBox(infobox_id) {
        var domId = $('#' + infobox_id);
        if (domId.css('display') === 'none') {
            $('.faqTabContent').hide();
            domId.show();
        } else {
            domId.hide();
        }
    };

    /**
     * Adds the link to the attachment in the main FAQ window
     * @param attachmentId
     * @param fileName
     * @param recordId
     * @param recordLang
     */
    addAttachmentLink = function addAttachmentLink(attachmentId, fileName, recordId, recordLang) {
        window.opener.
            $('.adminAttachments').
            append(
                '<li>' +
                '<a href="../index.php?action=attachment&id=' + attachmentId + '">' + fileName + '</a>' +
                '<a class="label label-danger" href="?action=delatt&amp;record_id=' + recordId +
                '&amp;id=' + attachmentId + '&amp;lang=' + recordLang + '">' +
                '<i aria-hidden="true" class="fa fa-trash"></i></a>' +
                '</li>'
            );
        window.close();
    };

    /**
     * Closes the current window
     *
     */
    closeWindow = function closeWindow() {
        window.close();
    };

    /**
     * Saves all content from the given form via Ajax
     *
     * @param action   Actions: savecomment, savefaq, savequestion,
     *                          saveregistration, savevoting, sendcontact,
     *                          sendtofriends
     * @param formName Name of the current form
     *
     * @return void
     */
    window.saveFormValues = function saveFormValues(action, formName) {
        var formValues = $('#formValues');

        $('#loader').show();
        $('#loader').fadeIn(400).html('<img src="assets/img/ajax-loader.gif">Saving ...');

        $.ajax({
            type:     'post',
            url:      'ajaxservice.php?action=' + action,
            data:     formValues.serialize(),
            dataType: 'json',
            cache:    false,
            success:  function (json) {
                if (json.success === undefined) {
                    $('#' + formName + 's').html(
                        '<p class="alert alert-danger">' +
                        '<button type="button" class="close" data-dismiss="alert">&times;</button>' +
                        json.error +
                        '</p>'
                    );
                    $('#loader').hide();
                } else {
                    $('#' + formName + 's').html(
                        '<p class="alert alert-success">' +
                        '<button type="button" class="close" data-dismiss="alert">&times;</button>' +
                        json.success +
                        '</p>'
                    );
                    $('#' + formName + 's').fadeIn('slow');
                    $('#loader').hide();
                    $('#' + formName + 'Form').hide();
                    $('#formValues')[0].reset();
                    // @todo add reload of content
                }
            }
        });

        return false;
    };

    /**
     * Saves the voting by Ajax
     *
     * @param type
     * @param id
     * @param value
     * @param lang
     */
    saveVoting = function saveVoting(type, id, value, lang) {
        $.ajax({
            type:     'post',
            url:      'ajaxservice.php?action=savevoting',
            data:     'type=' + type + '&id=' + id + '&vote=' + value + '&lang=' + lang,
            dataType: 'json',
            cache:    false,
            success:  function (json) {
                if (json.success === undefined) {
                    $('#votings').append(
                        '<p class="alert alert-danger">' +
                        '<button type="button" class="close" data-dismiss="alert">&times;</button>' +                        json.error +
                        '</p>'
                    );
                    $('#loader').hide();
                } else {
                    $('#votings').append(
                        '<p class="alert alert-success">' +
                        '<button type="button" class="close" data-dismiss="alert">&times;</button>' +                        json.success +
                        '</p>');
                    $('#rating').empty().append(json.rating);
                    $('#votings').fadeIn('slow');
                    $('#loader').hide();
                }
            }
        });

        return false;
    };

    /**
     * Checks the content of a question by Ajax
     *
     */
    window.checkQuestion = function checkQuestion() {
        var formValues = $('#formValues');

        $('#loader').show();
        $('#loader').fadeIn(400).html('<img src="assets/img/ajax-loader.gif">Saving ...');

        $.ajax({
            type:     'post',
            url:      'ajaxservice.php?action=savequestion',
            data:     formValues.serialize(),
            dataType: 'json',
            cache:    false,
            success:  function (json) {
                if (json.result === undefined && json.success === undefined) {
                    $('#qerror').html(
                        '<p class="alert alert-danger">' +
                        '<button type="button" class="close" data-dismiss="alert">&times;</button>' +                        json.error +
                        '</p>'
                    );
                    $('#loader').hide();
                } else if (json.success === undefined) {
                    $('#qerror').empty();
                    $('.hint-search-suggestion').show();
                    $('#questionForm').fadeOut('slow');
                    $('#answerForm').html(json.result);
                    $('#answerForm').fadeIn('slow');
                    $('#loader').hide();
                    $('#formValues').append('<input type="hidden" name="save" value="1" />');
                    $('#captcha').val('');
                } else {
                    $('#answers').html(
                        '<p class="alert alert-success">' +
                        '<button type="button" class="close" data-dismiss="alert">&times;</button>' +
                        json.success +
                        '</p>'
                    );
                    $('#answers').fadeIn('slow');
                    $('#answerForm').fadeOut('slow');
                    $('#loader').hide();
                    $('#formValues').hide();
                }
            }
        });

        return false;
    };


    $('#captcha-button').click(function() {
        var action = $(this).data('action');
        $.ajax({
            url: 'index.php?action=' + action + '&gen=img&ck=' + new Date().getTime(),
            success: function () {
                var captcha = $('#captcha');
                $('#captchaImage').attr('src', 'index.php?action=' + action + '&gen=img&ck=' + new Date().getTime());
                captcha.val('');
                captcha.focus();
            }
        });
    });
});

/**
 * Setup functions
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/.
 *
 * @category  phpMyFAQ
 * @package   JavaScript
 * @author    Thorsten Rinne <thorsten@phpmyfaq.de>
 * @copyright 2015-2018 phpMyFAQ Team
 * @license   http://www.mozilla.org/MPL/2.0/ Mozilla Public License Version 2.0
 * @link      http://www.phpmyfaq.de
 * @since     2015-12-24
 */

/*global $: false */

$(document).ready(function() {

    'use strict';

    var setupForm = $('.form-horizontal'),
        setupType = $('#sql_type'),
        setupTypeOptions = $('#sql_type option'),
        $dbSqlite = $('#dbsqlite'),
        $dbFull = $('#dbdatafull');

    var addInput = function (event) {

        var current = $(event.currentTarget);
        var tag = current.parent().parent();

        if ('add' === current.attr('data-action')) {
            tag.after(tag.clone().find('input').val('').find('span.input-group-addon').remove().end());
        }

        return false;
    };

    var selectDatabaseSetup = function () {

        switch ($(this).val()) {
            case 'sqlite3':
                $dbSqlite.show();
                $dbFull.hide();
                break;
            default:
                $dbSqlite.hide();
                $dbFull.show();
                break;
        }
    };

    setupForm.find('a').on('click', addInput);
    setupType.on('change', selectDatabaseSetup);

    if (setupTypeOptions.length === 1 && setupType.val() === 'sqlite3') {
        $dbSqlite.show().removeClass('hide');
        $dbFull.hide();
    }

});